import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.MalformedURLException;

class JEditorPaneDemo
{
	public static void main(String args[])
	{
		new MainWindow();
	}
}

class MainWindow extends JFrame
{
	// o
	JEditorPane html_view;
	JTextField text_url;
	JComboBox encoding_list;
	File current_path = new File("");

	// 萔
	final String line_separator = System.getProperty("line.separator");
	final String file_separator = System.getProperty("file.separator");
	final String ENCODING_SJIS = "Shift_JIS";
	final String ENCODING_EUC  = "EUC-JP";

	public MainWindow()
	{
		super("Local HTML Viewer");
		setBackground(Color.white);

		// EChEXi̒ǉ
		WindowListener listener = new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				System.exit(0);
			}
		};
		addWindowListener(listener);

		// HTML\̍\z
		html_view = new JEditorPane("text/html","<h1 align = \"center\">Html Viewer</h1>");
		html_view.setEditable(false);

		// nCp[NXi̒ǉ
		HyperlinkListener listener_html_view = new HyperlinkListener()
		{
			public void hyperlinkUpdate(HyperlinkEvent e)
			{
				if(e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
				{
					File link_target = new File(current_path.getAbsolutePath() + file_separator + e.getDescription());
					html_view.setText(getTextFromFile(link_target));
					try
					{
						text_url.setText(link_target.toURL().toString());
					}
					catch(MalformedURLException me)
					{
						System.err.println(me);
					}
				}
			}
		};
		html_view.addHyperlinkListener(listener_html_view);

		// t@CJ{^̒ǉ
		JButton button_open = new JButton("Open");
		ActionListener listener_button_open = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				// t@CJ_CAO̕\
				JFileChooser file_choose = new JFileChooser(current_path);
				if(file_choose.showOpenDialog(MainWindow.this) == JFileChooser.APPROVE_OPTION)
				{
					File file = file_choose.getSelectedFile();
					current_path = new File(file.getParent());

					html_view.setText(getTextFromFile(file));
					try
					{
						text_url.setText(file.toURL().toString());
					}
					catch(MalformedURLException me)
					{
						System.err.println(me);
					}
				}
			}
		};
		button_open.addActionListener(listener_button_open);

		// URL\̒ǉ
		text_url = new JTextField(30);
		text_url.setEditable(false);

		// GR[fBOXg֒ǉ
		encoding_list = new JComboBox();
		encoding_list.addItem(ENCODING_SJIS);
		encoding_list.addItem(ENCODING_EUC);

		// c[o[̒`
		JToolBar toolbar = new JToolBar(JToolBar.HORIZONTAL);
		toolbar.setLayout(new FlowLayout());
		toolbar.add(button_open);
		toolbar.add(text_url);
		toolbar.add(encoding_list);

		// HTML\փXN[o[ǉ
		JScrollPane scrollview = new JScrollPane(html_view);

		// EChEփR|[lgǉ
		JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
		panel.add(toolbar,BorderLayout.NORTH);
		panel.add(scrollview,BorderLayout.CENTER);
		setContentPane(panel);

		// EChE̕\
		setSize(800,600);
		setVisible(true);
	}

	public String getTextFromFile(File file)
	{
		String text = "";
		try
		{
			// w̃GR[fBOœ̓Xg[\z
			String encoding = encoding_list.getSelectedItem().toString();
			FileInputStream input = new FileInputStream(file);
			BufferedReader reader = new BufferedReader(new InputStreamReader(input,encoding));

			// StringIuWFNgɓǂݍ
			String buffer;
			while((buffer = reader.readLine()) != null)
			{
				// Meta^O܂ލs𖳎
				if(buffer.toLowerCase().indexOf("meta http-equiv") == -1)
				{
					text = text + buffer + line_separator;
				}
			}
		}
		catch(IOException e)
		{
			System.err.println(e);
		}

		return(text);
	}
}